(use-modules
  (gnu)
  (base-system)
  (gnu packages tex)
  (nongnu packages mozilla)
  (nongnu packages nvidia)
  (gnu packages networking)
  (gnu packages shells)
  (gnu packages pulseaudio)
  (gnu packages virtualization)
  (gnu packages spice)
  (gnu packages vulkan)
  (gnu packages pdf)
  (gnu packages commencement)
  (gnu packages base)
  (gnu packages embedded)
  (gnu packages linux)
  (gnu packages docker)
  (gnu services docker)
  (gnu packages audio)
  (gnu services cups)
  (gnu services virtualization)
  (gnu services networking)
  (gnu services xorg)
  (gnu services desktop)
  (gnu services dbus)
  (gnu services linux)
  (gnu packages cups)
  (gnu packages python)
  (gnu packages xorg)
  (gnu packages scanner)
  (gnu packages dns)
  (gnu services shepherd)
  (gnu services base))

; (define (nvidia-insmod-shepherd-service config)
;   (list (shepherd-service
;          (provision '(nvidia-insmod))
;          (requirement '())
;          (start #~(lambda _ (and
;                               (zero? (system* (string-append #$nvidia-driver "/bin/nvidia-insmod"))))))
;          (one-shot? #t)
;          (auto-start? #t)
;          (respawn? #f))))
;
;(define nvidia-insmod-service-type
;  (service-type
;    (name 'nvidia-insmod-name)
;    (extensions
;      (list (service-extension shepherd-root-service-type nvidia-insmod-shepherd-service)))
;    (default-value '())))

(operating-system
  (inherit base-desktop-system)
  (host-name "otto")
  (hosts-file
    (plain-file "hosts"
    (string-append (local-host-aliases host-name)
"# LAN geofff.homelab ip
192.168.86.2 geofff.homelab\n")))
  (kernel-arguments '("modprobe.blacklist=nouveau"))
  (packages (append (list blueman bluez bluez-alsa pulseaudio docker python openvswitch
                          qemu texlive firefox pavucontrol mupdf gcc-toolchain gnu-make
                          gcc-arm-none-eabi-7-2018-q2-update sane-backends-minimal xsane
                          cups xf86-video-nv xf86-input-libinput vulkan-loader vulkan-tools
                          (list isc-bind "utils")) %my-desktop-packages))
  (services (append (list
                      (simple-service 'blueman dbus-root-service-type (list blueman))
                      (bluetooth-service #:auto-enable? #t)
                      (service docker-service-type)
                      (service openvswitch-service-type)
                      (set-xorg-configuration
                        (xorg-configuration
                          (keyboard-layout %default-keyboard-layout)))
                      (service sane-service-type)
                      (service cups-service-type
                               (cups-configuration
                                 (web-interface? #t))))
                    (modify-services %my-desktop-services
                      (udev-service-type config =>
                                         (udev-configuration (inherit config)
                                                             (rules (append (list
                                                                              %usb-udev-rule)
                                                                      (udev-configuration-rules config))))))))
  (users (cons* (user-account
                  (name "nmetz")
                  (comment "Noah Metz")
                  (group "users")
                  (home-directory "/home/nmetz")
                  (shell (file-append zsh "/bin/zsh"))
                  (supplementary-groups
                    `("wheel" "netdev" "audio" "video" "usb" "kvm" "lp" "docker")))
                %my-base-user-accounts))
  (file-systems
    (cons* (file-system
             (mount-point "/boot/efi")
             (device (uuid "6E88-FE62" 'fat32))
             (type "vfat"))
           (file-system
             (mount-point "/")
             (device
               (uuid "ba93a043-9e58-466f-b90f-bf2a6bbf91fe"
                     'ext4))
             (type "ext4"))
           %base-file-systems)))

