(use-modules
  (gnu)
  (base-system)
  (gnu packages tex)
  (nongnu packages mozilla)
  (gnu packages networking)
  (gnu packages shells)
  (gnu packages pulseaudio)
  (gnu packages virtualization)
  (gnu packages spice)
  (gnu packages vulkan)
  (gnu packages pdf)
  (gnu packages commencement)
  (gnu packages base)
  (gnu packages embedded)
  (gnu services cups)
  (gnu services virtualization)
  (gnu services xorg)
  (gnu services desktop)
  (gnu services linux)
  (gnu packages cups)
  (gnu packages xorg)
  (gnu packages scanner)
  (gnu packages dns)
  (gnu services shepherd)
  (gnu services base))

(operating-system
  (inherit base-desktop-system)
  (host-name "patrache")
  (packages (append (list autoconf automake qemu texlive firefox pavucontrol mupdf gcc-toolchain gnu-make gcc-arm-none-eabi-7-2018-q2-update sane-backends-minimal xsane cups (list isc-bind "utils")) %my-desktop-packages))
  (services (append (list
                      (set-xorg-configuration
                        (xorg-configuration
                          (keyboard-layout %default-keyboard-layout)))
                      (service sane-service-type)
                      (service cups-service-type
                               (cups-configuration
                                 (web-interface? #t))))
                    (modify-services %my-desktop-services
                      (udev-service-type config =>
                                         (udev-configuration (inherit config)
                                                             (rules (append (list
                                                                              %usb-udev-rule)
                                                                      (udev-configuration-rules config))))))))
  (users (cons* (user-account
                  (name "nmetz")
                  (comment "Noah Metz")
                  (group "users")
                  (home-directory "/home/nmetz")
                  (shell (file-append zsh "/bin/zsh"))
                  (supplementary-groups
                    `("wheel" "netdev" "audio" "video" "usb" "kvm")))
                %my-base-user-accounts))
  (file-systems
    (cons* (file-system
             (mount-point "/boot/efi")
             (device (uuid "50C2-89C6" 'fat32))
             (type "vfat"))
           (file-system
             (mount-point "/")
             (device
               (uuid "817a54a1-a8a9-49b5-883d-33fdfd06404d"
                     'ext4))
             (type "ext4"))
           %base-file-systems)))

